diff -uNrd gameserv-1.1.7.dist/configscript.cpp gameserv-1.1.7/configscript.cpp
--- gameserv-1.1.7.dist/configscript.cpp	Mon Feb  2 14:20:36 2004
+++ gameserv-1.1.7/configscript.cpp	Thu Feb 12 12:42:59 2004
@@ -29,16 +29,25 @@
 		outfile << "#define UNREAL" << endl;
 		outfile << "#undef BAHAMUT" << endl;
 		outfile << "#undef P10" << endl;
+		outfile << "#undef HYBRID" << endl;
 		break;
 	    case '2':
 		outfile << "#undef UNREAL" << endl;
 		outfile << "#define BAHAMUT" << endl;
 		outfile << "#undef P10" << endl;
+		outfile << "#undef HYBRID" << endl;
 		break;
 	    case '3':
 		outfile << "#undef UNREAL" << endl;
 		outfile << "#undef BAHAMUT" << endl;
 		outfile << "#define P10" << endl;
+		outfile << "#undef HYBRID" << endl;
+		break;
+	    case '4':
+		outfile << "#undef UNREAL" << endl;
+		outfile << "#undef BAHAMUT" << endl;
+		outfile << "#undef P10" << endl;
+		outfile << "#define HYBRID" << endl;
 		break;
 	    default:
 		break;
@@ -78,7 +87,8 @@
 	cout << "Choose your IRCD" << endl;
 	cout << "1. Unreal3.x" << endl
 	     << "2. bahamut-1.4.x" << endl
-	     << "3. ircu 2.10.x (P10)" << endl;
+	     << "3. ircu 2.10.x (P10)" << endl
+	     << "4. ircd-hybrid, ircd-ratbox, or csircd" << endl;
 	cout << "Make your selection: ";
     }
 
diff -uNrd gameserv-1.1.7.dist/tcpclient.cpp gameserv-1.1.7/tcpclient.cpp
--- gameserv-1.1.7.dist/tcpclient.cpp	Wed Feb 11 13:14:52 2004
+++ gameserv-1.1.7/tcpclient.cpp	Thu Feb 12 12:41:03 2004
@@ -27,7 +27,7 @@
 using std::ifstream;
 
 char *PACKAGE = "GameServ";
-char *VERSION = "1.1.7";
+char *VERSION = "1.1.7+hybrid_0.4";
 
 int sock;
 long timestamp;
@@ -69,6 +69,13 @@
         raw("NICK %S 1 %d +o %s %s %s 0 :GameServ", time(NULL), gsident, gshost, 
 		servername);
 	raw(":%s SJOIN %d %d %s +mnt :@%S", servername, time(NULL), time(NULL), c_Forest);
+#elif defined(HYBRID)
+	raw("PASS %s :TS", remotepass);
+	raw("SERVER %s 1 :%s", servername, servername);
+	raw("NICK %S 1 %d +o %s %s %s :GameServ", time(NULL), gsident, gshost,
+		servername);
+	// Sending a timestamp of 1 to force ops.
+	raw(":%s SJOIN 1 %s +ntm :@%S", servername, c_Forest);
 #elif defined(P10)
 	// Server numeric is: []  <-- must be unique
 	raw("PASS :%s", remotepass);
@@ -80,8 +87,10 @@
 #if defined(P10)
 	raw("%s T %s :%s", gsnum, c_Forest, c_ForestTopic);
 	raw("[] EB");  // End burst
-#else   
+#else 
+#ifndef HYBRID
 	raw(":%S MODE %s +o %S", c_Forest);
+#endif
 	raw(":%S TOPIC %s :%s", c_Forest, c_ForestTopic);
 #endif
 
@@ -276,17 +285,29 @@
 
 	#if defined(BAHAMUT)
 	} else if (stricmp(cmd, "SJOIN") == 0) {
-	    char *channel, *nick;
+	    char *channel, *nick, *tmp, *rest;
 	    strtok(NULL, " "); // Ignore the TS
+#ifndef HYBRID
 	    strtok(NULL, " "); // Ignore the TS
+#endif
 	    channel = strtok(NULL, " ");
-	    strtok(NULL, " ");
-	    nick = strtok(NULL, " ");
-	    nick++; // Get rid of the :
-	    if (stricmp(channel, c_Forest) == 0 && is_playing(nick))
-		raw(":%S MODE %s +v %s", channel, nick);
-	#endif
+           rest = strtok(NULL, "");
+           tmp = strchr(rest, ':');
+           tmp++;
+           nick = strtok(tmp, " ");
+           while (nick != NULL)
+           {
+               if (*nick == '@')
+                   nick++;
+               if (*nick == '+')
+                   nick++; // Assume for users set op and voice, they
+                            // are never passed as +@nick
+               if (stricmp(channel, c_Forest) == 0 && is_playing(nick))
+                   raw(":%S MODE %s +v %s", channel, nick);
 
+               nick = strtok(NULL, " ");
+           }
+#endif
 	} else {
 	    #ifdef DEBUGMODE
 		log("Unrecognized Message: cmd = %s   source = %s", cmd, source);
